/****************************************************************************************** 
 *	Chili DirectX Framework Version 11.12.17											  *	
 *	Game.h																				  *
 *	Copyright 2011 PlanetChili.net														  *
 *																						  *
 *	This file is part of The Chili DirectX Framework.									  *
 *																						  *
 *	The Chili DirectX Framework is free software: you can redistribute it and/or modify	  *
 *	it under the terms of the GNU General Public License as published by				  *
 *	the Free Software Foundation, either version 3 of the License, or					  *
 *	(at your option) any later version.													  *
 *																						  *
 *	The Chili DirectX Framework is distributed in the hope that it will be useful,		  *
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of						  *
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the						  *
 *	GNU General Public License for more details.										  *
 *																						  *
 *	You should have received a copy of the GNU General Public License					  *
 *	along with The Chili DirectX Framework.  If not, see <http://www.gnu.org/licenses/>.  *
 ******************************************************************************************/
#pragma once

#include "D3DGraphics.h"
#include "Keyboard.h"

#define ENEMIES 5

class Game
{
	struct ENEMY
	{
		float x;
		float y;
		float W;
		float L;
	};


public:
	Game( HWND hWnd,const KeyboardServer& kServer );
	void Go();
private:

	void DrawPlayer( int x,int y,int rad );
	void DrawAura( int x,int y,int rad );
	void DrawEnemy( int x,int y,int wigth,int length );
	void DrawTargetLine( int x1,int y1,int x2,int y2 );
	void DrawLifeBar( int x,int y,int Wigth );
	void DrawEndScreen_Game( int x,int y );
	void DrawEndScreen_Over( int x,int y );
	void DrawBackground();

	void ComposeFrame();

	void PlayerInteraction();
	void AuraInteraction();
	void EnemyInteraction();

	void PlayerLife();
	/********************************/
	/*  User Functions              */

	// TODO: User functions go here

	/********************************/
private:
	D3DGraphics gfx;
	KeyboardClient kbd;
	/********************************/
	/*  User Variables              */

	int playerX;
	int playerY;
	int playerRad;

	int lifebarWigth;
	float damage;
	
	int auraX;
	int auraY;
	float auraRad;

	ENEMY enemy[ ENEMIES ];
	int nEnemies;

	bool game_is_over;



	/********************************/
};