/****************************************************************************************** 
 *	Chili DirectX Framework Version 11.12.17											  *	
 *	Game.cpp																			  *
 *	Copyright 2011 PlanetChili.net														  *
 *																						  *
 *	This file is part of The Chili DirectX Framework.									  *
 *																						  *
 *	The Chili DirectX Framework is free software: you can redistribute it and/or modify	  *
 *	it under the terms of the GNU General Public License as published by				  *
 *	the Free Software Foundation, either version 3 of the License, or					  *
 *	(at your option) any later version.													  *
 *																						  *
 *	The Chili DirectX Framework is distributed in the hope that it will be useful,		  *
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of						  *
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the						  *
 *	GNU General Public License for more details.										  *
 *																						  *
 *	You should have received a copy of the GNU General Public License					  *
 *	along with The Chili DirectX Framework.  If not, see <http://www.gnu.org/licenses/>.  *
 ******************************************************************************************/
#include "Game.h"
#include <stdlib.h>
#include <math.h>


Game::Game( HWND hWnd,const KeyboardServer& kServer )
:	gfx ( hWnd ),
	kbd( kServer ),
	playerX( 200 ),
	playerY( 300 ),
	playerRad( 10 ),
	auraX( playerX ),
	auraY( playerY ),
	auraRad( playerRad/2.0f ),
	nEnemies( ENEMIES ),
	lifebarWigth( 375 ),
	damage( 375.0 ),
	game_is_over( false )
{

	for( int index = 0; index < nEnemies; index++ )
	{
		enemy[ index ].x = (rand() % 80) + 699;
		enemy[ index ].y = (rand() % 510) + 49;
		enemy[ index ].W = 20;
		enemy[ index ].L = 20;
	}
}

void Game::Go()
{
	if( !game_is_over )
	{
		PlayerInteraction();
		AuraInteraction();
		EnemyInteraction();
		PlayerLife();
	}

	gfx.BeginFrame();
	ComposeFrame();
	gfx.EndFrame();
}

void Game::DrawPlayer( int x,int y,int rad )
{	
	gfx.DrawDisk( x,y,rad,255,20,20 );
}

void Game::DrawAura( int x,int y,int rad )
{
	gfx.DrawCircle( x,y,rad,255,255,20 );
}

void Game::DrawEnemy( int x,int y,int wigth,int length )
{
	gfx.DrawRectangle( x,y,wigth,length,255,255,255 );
}

void Game::DrawTargetLine( int x1,int y1,int x2,int y2 )
{
	gfx.DrawLine( x1,y1,x2,y2,100,10,10 );
}

void Game::DrawLifeBar( int x,int y,int Wigth )
{
	gfx.DrawRectangle( x,y,375,20,80,8,8 );
	gfx.DrawRectangle( x,y,Wigth,20,255,20,20 );

	gfx.DrawLine( x - 1,y - 1,387,y - 1,255,255,20 );
	gfx.DrawLine( x - 1,y + 20,387,y + 20,255,255,20 );
	gfx.DrawLine( x - 1,y - 1,x - 1,y + 20,255,255,20 );
	gfx.DrawLine( 387,y - 1,387,y + 20,255,255,20 );
	
}

void Game::DrawEndScreen_Game( int x,int y )
{
	gfx.PutPixel(29 + x, 28 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 28 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 28 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 28 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 28 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 28 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 28 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 28 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 28 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 28 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 28 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 28 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 28 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 28 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 28 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 29 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 29 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 29 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 29 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 29 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 29 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 29 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 29 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 29 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 29 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 29 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 29 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 29 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 29 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 29 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 30 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 30 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 30 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 30 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 30 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 30 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 30 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 30 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 30 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 30 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 30 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 30 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 30 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 30 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 30 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 30 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 30 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 30 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 30 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 30 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 30 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 31 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 31 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 31 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 31 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 31 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 31 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 31 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 31 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 31 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 31 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 31 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 31 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 31 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 31 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 31 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 31 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 31 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 31 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 31 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 31 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 31 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 32 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 33 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 34 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 35 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 36 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 37 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 38 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(195 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(196 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(197 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(195 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(196 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(197 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(0 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(1 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(2 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(195 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(196 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(197 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(195 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(196 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(197 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(195 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(196 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(197 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(195 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(196 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(197 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(160 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(161 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(162 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(163 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(164 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(165 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(166 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(116 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(117 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(118 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 113 + y, 157, 0, 0);

}

void Game::DrawEndScreen_Over( int x,int y )
{
	gfx.PutPixel(29 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 39 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 40 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 41 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 42 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 43 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 44 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 45 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 46 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 47 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 48 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 49 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 50 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 51 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 52 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 53 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 54 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 55 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 56 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 57 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 58 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 59 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 60 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 61 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 62 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 63 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 64 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 65 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 66 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 67 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 68 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 69 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 70 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 71 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 72 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(61 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(68 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(69 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(70 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(71 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(72 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(108 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(109 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(110 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(111 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(112 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(113 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(114 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(115 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 73 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(61 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(68 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(69 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(70 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(71 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(72 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(108 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(109 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(110 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(111 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(112 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(113 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(114 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(115 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 74 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(61 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(68 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(69 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(70 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(71 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(72 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(108 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(109 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(110 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(111 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(112 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(113 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(114 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(115 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 75 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(61 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(68 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(69 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(70 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(71 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(72 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(108 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(109 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(110 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(111 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(112 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(113 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(114 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(115 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 76 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(61 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(68 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(69 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(70 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(71 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(72 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(108 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(109 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(110 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(111 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(112 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(113 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(114 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(115 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 77 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(61 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(68 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(69 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(70 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(71 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(72 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(108 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(109 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(110 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(111 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(112 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(113 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(114 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(115 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 78 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(61 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(68 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(69 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(70 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(71 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(72 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(108 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(109 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(110 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(111 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(112 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(113 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(114 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(115 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(181 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(182 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(183 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(184 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(185 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(186 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(187 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(188 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 79 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(61 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(71 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(72 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(105 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(106 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(107 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(108 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(109 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(110 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(111 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(112 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(151 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(152 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(195 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(196 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(197 + x, 80 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(61 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(71 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(72 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(105 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(106 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(107 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(108 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(109 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(110 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(111 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(112 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(151 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(152 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(195 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(196 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(197 + x, 81 + y, 157, 0, 0);
	gfx.PutPixel(3 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(4 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(5 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(60 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(61 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(71 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(72 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(105 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(106 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(107 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(108 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(109 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(110 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(111 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(112 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(151 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(152 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(178 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(179 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(180 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(189 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(190 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(191 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(195 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(196 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(197 + x, 82 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(71 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(72 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(105 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(106 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(107 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(108 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(109 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(110 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(111 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(112 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(151 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(152 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(153 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(154 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(195 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(196 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(197 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(198 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(199 + x, 83 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(71 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(72 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(105 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(106 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(107 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(108 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(109 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(110 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(111 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(112 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(151 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(152 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(153 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(154 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(195 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(196 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(197 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(198 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(199 + x, 84 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(71 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(72 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(73 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(105 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(106 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(107 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(108 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(109 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(110 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(111 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(112 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(151 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(152 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(153 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(154 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(175 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(176 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(177 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(192 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(193 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(194 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(195 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(196 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(197 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(198 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(199 + x, 85 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(102 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(103 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(104 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(105 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(106 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(107 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(108 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(109 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(151 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(152 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(153 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(154 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(195 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(196 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(197 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(198 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(199 + x, 86 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(102 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(103 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(104 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(105 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(106 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(107 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(108 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(109 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(151 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(152 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(153 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(154 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(195 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(196 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(197 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(198 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(199 + x, 87 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(102 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(103 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(104 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(105 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(106 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(107 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(108 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(109 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(151 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(152 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(153 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(154 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(195 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(196 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(197 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(198 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(199 + x, 88 + y, 157, 0, 0);
	gfx.PutPixel(6 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(7 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(8 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(57 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(58 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(59 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(102 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(103 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(104 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(105 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(106 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(107 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(108 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(109 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(151 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(152 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(153 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(154 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(172 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(173 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(174 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(195 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(196 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(197 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(198 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(199 + x, 89 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(102 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(103 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(104 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(105 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(106 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(107 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(108 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(109 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(151 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(152 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 90 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(102 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(103 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(104 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(105 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(106 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(107 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(108 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(109 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(151 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(152 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 91 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(74 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(75 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(76 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(102 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(103 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(104 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(105 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(106 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(107 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(108 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(109 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(151 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(152 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 92 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(102 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(103 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(104 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(105 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(106 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(107 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(151 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(152 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 93 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(102 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(103 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(104 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(105 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(106 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(107 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(151 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(152 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 94 + y, 157, 0, 0);
	gfx.PutPixel(9 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(10 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(11 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(54 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(55 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(56 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(102 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(103 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(104 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(105 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(106 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(107 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(151 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(152 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 95 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(102 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(103 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(104 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(105 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(106 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(107 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 96 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(102 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(103 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(104 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(105 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(106 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(107 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 97 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(102 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(103 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(104 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(105 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(106 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(107 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 98 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(77 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(78 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(102 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(103 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(104 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(105 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(106 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(107 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 99 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(102 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(103 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(104 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 100 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(102 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(103 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(104 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 101 + y, 157, 0, 0);
	gfx.PutPixel(12 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(13 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(14 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(51 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(52 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(53 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(102 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(103 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(104 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 102 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(102 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(103 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(104 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(151 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(152 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 103 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(102 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(103 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(104 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(151 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(152 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 104 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(102 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(103 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(104 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(151 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(152 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 105 + y, 157, 0, 0);
	gfx.PutPixel(15 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(16 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(48 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(49 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(50 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(79 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(80 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(81 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(102 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(103 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(104 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(119 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(120 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(121 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(151 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(152 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 106 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(151 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(152 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 107 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(151 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(152 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 108 + y, 157, 0, 0);
	gfx.PutPixel(17 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(18 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(19 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(20 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(21 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(22 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(43 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(44 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(45 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(46 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(47 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(122 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(123 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(150 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(151 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(152 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 109 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 110 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 111 + y, 157, 0, 0);
	gfx.PutPixel(23 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(24 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(25 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(26 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(27 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(28 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(37 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(38 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(39 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(40 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(41 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(42 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(82 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(83 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(84 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(99 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(100 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(101 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(124 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(125 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(126 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(147 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(148 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(149 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 112 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 113 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 114 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 115 + y, 157, 0, 0);
	gfx.PutPixel(29 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(30 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(31 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(32 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(33 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(34 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(35 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(36 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(85 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(86 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(87 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(88 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(89 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(90 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(91 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(92 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(93 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(94 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(95 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(96 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(97 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(98 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(127 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(128 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(129 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(130 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(131 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(132 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(133 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(134 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(135 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(136 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(137 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(138 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(139 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(140 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(141 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(142 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(143 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(144 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(145 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(146 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(167 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(168 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(169 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(170 + x, 116 + y, 157, 0, 0);
	gfx.PutPixel(171 + x, 116 + y, 157, 0, 0);

}

void Game::DrawBackground()
{

	gfx.DrawLine( 100,1,100,598,10,10,50 );
	gfx.DrawLine( 200,1,200,598,10,10,50 );
	gfx.DrawLine( 300,1,300,598,10,10,50 );
	gfx.DrawLine( 400,1,400,598,10,10,50 );
	gfx.DrawLine( 500,1,500,598,10,10,50 );
	gfx.DrawLine( 600,1,600,598,10,10,50 );
	gfx.DrawLine( 700,1,700,598,10,10,50 );

	gfx.DrawLine( 1,100,798,100,10,10,50 );
	gfx.DrawLine( 1,200,798,200,10,10,50 );
	gfx.DrawLine( 1,300,798,300,10,10,50 );
	gfx.DrawLine( 1,400,798,400,10,10,50 );
	gfx.DrawLine( 1,500,798,500,10,10,50 );

	gfx.DrawRectangle( 1,1,798,5,20,20,120 );
	gfx.DrawRectangle( 1,594,798,5,20,20,120 );
	gfx.DrawRectangle( 1,1,5,598,20,20,120 );
	gfx.DrawRectangle( 794,1,5,598,20,20,120 );

	gfx.DrawRectangle( 1,40,798,5,20,20,120 );

}

//Contains controls.
void Game::PlayerInteraction()
{
	int speed = 3;
	int beam = 20;

	if( kbd.EnterIsPressed() )
	{
		auraX = auraX + beam;
	}
	else if( auraX != playerX )
	{
		auraX = auraX + beam;
	}
	else
	{
		auraX = playerX;
		auraY = playerY;
	}

	if( kbd.SpaceIsPressed() )
	{
		if( (auraX = playerX) && (auraY = playerY) )
		{
			if( auraRad < 30 )
			{
				auraRad = auraRad + 0.4f;
			}
		}
	}
	if( kbd.UpIsPressed() )
	{
		playerY = playerY - speed;
		auraY = auraY - speed;
	}
	if( kbd.DownIsPressed() )
	{
		playerY = playerY + speed;
		auraY = auraY + speed;
	}
	if( kbd.LeftIsPressed() )
	{
		playerX = playerX - speed;
		auraX = auraX - speed;
		if( auraX != playerX )
		{
			auraX = auraX + speed;
		}
	}
	if( kbd.RightIsPressed() )
	{
		playerX = playerX + speed;
		auraX = auraX + speed;
		if( auraX != playerX )
		{
			auraX = auraX - speed;
		}
	}

	//Player screen detection.
	if( playerY + playerRad > 594 )
	{
		playerY = 594 - playerRad;
	}
	if( playerY < 45 + playerRad )
	{
		playerY = 45 + playerRad;
	}
	if( playerX + playerRad > 794 )
	{
		playerX = 794 - playerRad;
	}
	if( playerX < 5 + playerRad )
	{
		playerX = 5 + playerRad;
	}

}

//Contains damage values.
void Game::PlayerLife()
{
	for( int index = 0; index < nEnemies; index++ )
	{
		//Damage by letting the block pass.
		//Damage is dependent on size.

		if( (enemy[ index ].x < 5) &&
			enemy[ index ].L == 20 &&
			enemy[ index ].W == 20 )
		{
			damage = 375 / 5;
			enemy[ index ].W = enemy[ index ].W - 20;
			enemy[ index ].L = enemy[ index ].L - 20;
			
			lifebarWigth = lifebarWigth - damage;
		}

		if( (enemy[ index ].x < 5) &&
			enemy[ index ].L <= 19 &&
			enemy[ index ].W <= 19 && 
			enemy[ index ].L >= 15 &&
			enemy[ index ].W >= 15 )
		{
			damage = 375 / 7.5f;
			enemy[ index ].W = enemy[ index ].W - 20;
			enemy[ index ].L = enemy[ index ].L - 20;
			
			lifebarWigth = lifebarWigth - damage;
		}

		if( (enemy[ index ].x < 5) &&
			enemy[ index ].L <= 14 &&
			enemy[ index ].W <= 14 && 
			enemy[ index ].L >= 10 &&
			enemy[ index ].W >= 10 )
		{
			damage = 375 / 11.25f;
			enemy[ index ].W = enemy[ index ].W - 20;
			enemy[ index ].L = enemy[ index ].L - 20;
			
			lifebarWigth = lifebarWigth - damage;
		}

		if( (enemy[ index ].x < 5) &&
			enemy[ index ].L <= 8 &&
			enemy[ index ].W <= 8 && 
			enemy[ index ].L >= 5 &&
			enemy[ index ].W >= 5 )
		{
			damage = 375 / 16.875f;
			enemy[ index ].W = enemy[ index ].W - 20;
			enemy[ index ].L = enemy[ index ].L - 20;
			
			lifebarWigth = lifebarWigth - damage;
		}

		if( (enemy[ index ].x < 5) &&
			enemy[ index ].L <= 4 &&
			enemy[ index ].W <= 4 )
		{
			damage = 375 / 25.3125f;
			enemy[ index ].W = enemy[ index ].W - 20;
			enemy[ index ].L = enemy[ index ].L - 20;
			
			lifebarWigth = lifebarWigth - damage;
		}

		//Damage by getting hit by a block.
		//Damage is dependent on size.

		if( (playerX + playerRad >= enemy[ index ].x) &&
			(playerY + playerRad >= enemy[ index ].y) &&
			(playerX <= enemy[ index ].x + 20) &&
			(playerY <= enemy[ index ].y + 20) &&
			enemy[ index ].L == 20 &&
			enemy[ index ].W == 20 )
		{
			damage = 375 / 2.0f;
			lifebarWigth = lifebarWigth- damage;
		}

		if( (playerX + playerRad >= enemy[ index ].x) &&
			(playerY + playerRad >= enemy[ index ].y) &&
			(playerX <= enemy[ index ].x + 20) &&
			(playerY <= enemy[ index ].y + 20) &&
			enemy[ index ].L <= 19 &&
			enemy[ index ].W <= 19 && 
			enemy[ index ].L >= 15 &&
			enemy[ index ].W >= 15)
		{
			damage = 375 / 4.0f;
			lifebarWigth = lifebarWigth- damage;
		}

		if( (playerX + playerRad >= enemy[ index ].x) &&
			(playerY + playerRad >= enemy[ index ].y) &&
			(playerX <= enemy[ index ].x + 20) &&
			(playerY <= enemy[ index ].y + 20) &&
			enemy[ index ].L <= 14 &&
			enemy[ index ].W <= 14 && 
			enemy[ index ].L >= 10 &&
			enemy[ index ].W >= 10 )
		{
			damage = 375 / 6.0f;
			lifebarWigth = lifebarWigth- damage;
		}

		if( (playerX + playerRad >= enemy[ index ].x) &&
			(playerY + playerRad >= enemy[ index ].y) &&
			(playerX <= enemy[ index ].x + 20) &&
			(playerY <= enemy[ index ].y + 20) &&
			enemy[ index ].L <= 8 &&
			enemy[ index ].W <= 8 && 
			enemy[ index ].L >= 5 &&
			enemy[ index ].W >= 5 )
		{
			damage = 375 / 8.0f;
			lifebarWigth = lifebarWigth- damage;
		}

		if( (playerX + playerRad >= enemy[ index ].x)
			&& (playerY + playerRad >= enemy[ index ].y) &&
			(playerX <= enemy[ index ].x + 20) &&
			(playerY <= enemy[ index ].y + 20) &&
			enemy[ index ].L <= 4 &&
			enemy[ index ].W <= 4 )
		{
			damage = 375 / 10.0f;
			lifebarWigth = lifebarWigth- damage;
		}
	}
	if( lifebarWigth <= 0 )
	{
		lifebarWigth = 0 ;
		game_is_over = true;
	}
}

void Game::AuraInteraction()
{
	if( auraY + auraRad > 594 )
	{
		auraX = playerX;
		auraY = playerY;
		auraRad = playerRad / 2.0f;
	}
	if( auraY < 5 + auraRad )
	{
		auraX = playerX;
		auraY = playerY;
		auraRad = playerRad / 2.0f;
	}
	if( auraX + auraRad > 794 )
	{
		auraX = playerX;
		auraY = playerY;
		auraRad = playerRad / 2.0f;
	}
	if( auraX < 5 + auraRad )
	{
		auraX = playerX;
		auraY = playerY;
		auraRad = playerRad / 2.0f;
	}
}

void Game::EnemyInteraction()
{
	for( int index = 0; index < nEnemies; index++ )
	{
		float gravity = ( 85.0f / ((enemy[ index ].W + enemy[ index ].L) * 2.0f));

		enemy[ index ].x = enemy[ index ].x - gravity;

		//Block wall detection.
		if( (auraX + auraRad >= enemy[ index ].x) &&
			(auraY + auraRad >= enemy[ index ].y) &&
			(auraX <= enemy[ index ].x + 20) &&
			(auraY <= enemy[ index ].y + 20) &&
			(auraRad <= 30) )
		{
			enemy[ index ].W = enemy[ index ].W - 4;
			enemy[ index ].L = enemy[ index ].L - 4;
			enemy[ index ].x = enemy[ index ].x + 2;
			enemy[ index ].y = enemy[ index ].y + 2;

			auraX = playerX;
			auraY = playerY;
			auraRad = 5;

		}

		//Charge-shot doesn't seem to work for now.
		if( (auraX + auraRad >= enemy[ index ].x) &&
			(auraY + auraRad >= enemy[ index ].y) &&
			(auraX <= enemy[ index ].x + 20) &&
			(auraY <= enemy[ index ].y + 20) &&
			(auraRad >= 30) )
		{
			enemy[ index ].W = enemy[ index ].W - 20;
			enemy[ index ].L = enemy[ index ].L - 20;
			enemy[ index ].x = enemy[ index ].x + 10;
			enemy[ index ].y = enemy[ index ].y + 10;

		}
		//Resets block positions
		if( (enemy[ index ].W <= 0) && (enemy[ index ].L <= 0) )
		{
			enemy[ index ].W = 20;
			enemy[ index ].L = 20;
			enemy[ index ].x = (rand() % 80) + 699;
			enemy[ index ].y = (rand() % 510) + 49;

		}

	}
}

void Game::ComposeFrame()
{	DrawBackground();
	DrawAura( auraX,auraY,auraRad );
	for( int index = 0; index < nEnemies; index++ )
	{
		DrawEnemy( enemy[ index ].x,enemy[ index ].y,enemy[ index ].W,enemy[ index ].L );
	}
	DrawTargetLine( playerX,playerY,794,auraY );
	DrawPlayer( playerX,playerY,playerRad );
	DrawLifeBar( 12,12,lifebarWigth );

	if( game_is_over )
	{
		DrawEndScreen_Game( 300,100 );
		DrawEndScreen_Over( 300,200 );
	}
}